image: atlassian/default-image:4

node_version: &node_version
  image: node:18.17.0

default_step:
  step: &default_step
    <<: *node_version
    caches:
      - node
    script:
      - export NODE_OPTIONS=--max_old_space_size=3072
      - yarn --frozen-lock
      - yarn build
      # https://bitbucket.org/atlassian/aws-s3-deploy/src/master/
      - pipe: atlassian/aws-s3-deploy:1.5.0
        variables:
          AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
          AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
          AWS_DEFAULT_REGION: 'us-east-1'
          S3_BUCKET: $S3_BUCKET
          LOCAL_PATH: 'dist'

update_server:
  script: &update_server
    - pipe: atlassian/ssh-run:0.7.1
      variables:
        SSH_USER: $SSH_USER
        MODE: 'script'
        PORT: $PORT
        SERVER: $HOST
        COMMAND: "scripts/deploy.sh"
        EXTRA_ARGS: $EXTRA_ARGS
        ENV_VARS: >-
          DOCKER_PATH=$DOCKER_PATH

create_image: &create_image
  name: Create & Push image
  services:
    - docker
  script:
    - docker build -t $IMAGE_NAME:$TAGS .
    - pipe: atlassian/aws-ecr-push-image:2.2.0
      variables:
        AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
        AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
        AWS_DEFAULT_REGION: $AWS_REGION
        IMAGE_NAME: $IMAGE_NAME
        TAGS: $TAGS

pipelines:
  branches:
    develop:
      - step:
          deployment: Test
          <<: *create_image
      - step:
          name: Deploy on DEV
          deployment: Server_Test
          script: *update_server
    master:
      - step:
          name: Deploy on S3(CDN)
          deployment: DEMO
          <<: *default_step